var xmlHttp;

var XMLHttpFactories = [
	function () { return new window.XMLHttpRequest(); },
	function () { return new ActiveXObject("Msxml3.XMLHTTP"); },
	function () { return new ActiveXObject("Msxml2.XMLHTTP"); },
	function () { return new ActiveXObject("Microsoft.XMLHTTP"); }
];

function CreateXMLHttpRequest() {
    var xmlhttp = false;
    for (var i = 0; i < XMLHttpFactories.length; i++) {
        try {
            xmlhttp = XMLHttpFactories[i]();
        }
        catch (e) {
            continue;
        }
        break;
    }
    return xmlhttp;
}

function GetSwivelUrl(url) {
    return "./swivel/" + url;
}

function GetUsername() {
    var userField = document.getElementById("username");
    if (!userField || !userField.value) {
        return null;
    }
    var username = userField.value;
    return username;
}

function SetUserExists(exists) {
    var rowOtc = document.getElementById("spnOTC");
    var divImage = document.getElementById("spnSwivelImage");
    var divCp = document.getElementById("divChangePin");
    var divTuring = document.getElementById("divTuring");
    var divPinpad = document.getElementById("divPinpad");
    var chkUserExists = document.getElementById("userExists");
    if (divTuring) {
        divTuring.style.display = "none";
    }
    if (divPinpad) {
        divPinpad.style.display = "none";
    }
    if (exists) {
        if (rowOtc) {
            rowOtc.style.display = "";
        }
	    if (divImage) {
	        divImage.style.display = "";
	    }
        if (divCp) {
            divCp.style.display = document.getElementById("showChangePin").checked ? "" : "none";
        }
        if (document.getElementById("autoShow").checked) {
            ShowImage();
        }
        chkUserExists.checked = true;
    } else {
        if (rowOtc) {
            rowOtc.style.display = "none";
        }
        if (divImage) {
            divImage.style.display = "none";
        }
        if (divCp) {
            divCp.style.display = "none";
        }
        chkUserExists.checked = false;
    }
}

function OnUserExists() {
    if (xmlHttp.readyState != 4) return;
    var exists = false;
    if (xmlHttp.status == 200) {
        var resultText = ExtractText(xmlHttp.responseText);
        exists = (resultText.toLowerCase() == "true");
    }
    SetUserExists(exists);
}

function CheckUser() {
    var chkSwivelOff = document.getElementById("noSwivel");
    var chkAllowUnknown = document.getElementById("allowUnknown");
    if (!chkSwivelOff.checked) {
        if (!chkAllowUnknown.checked) {
            SetUserExists(true);
        } else {
            var username = GetUsername();
            if (username && username != "") {
                var pinsafeUrl = GetSwivelUrl("CheckUser.aspx?username=") + username + "&random=" + Math.floor(Math.random() * 100000);
                xmlHttp = CreateXMLHttpRequest();
                xmlHttp.onreadystatechange = OnUserExists;
                xmlHttp.open("GET", pinsafeUrl, true);
                xmlHttp.send(null);
            } else {
                SetUserExists(false);
            }
        }
    }
}

// Extract the raw text from an HTML-wrapped response.
function ExtractText(response) {
    if (!response) {
        return response;
    }
    var text = response.trim();
    if (text == "") {
        return text;
    }
    if (text.charAt(0) != "<") {
        return text;
    }
    do {
        var idx = text.indexOf(">");
        if (idx < 0) {
            return text;
        }
        text = text.substr(idx + 1).trim();
        if (text == "") {
            return text;
        }
        idx = text.indexOf("<");
        if (idx < 0) {
            return text;
        } 
        if (idx > 0) {
            return text.substring(0, idx - 1).trim();
        }
    } while (true);
}

function SetSwivelSettings(required, allowUnknown, showTuring, showMessage, autoShow, showPinpad, showChangePin) {
    var rowOtc = document.getElementById("OTCRow");
    var rowTuring = document.getElementById("divTuring");
    var rowPinpad = document.getElementById("divPinpad");
    var chkSwivelOff = document.getElementById("noSwivel");
    var chkAllowUnknown = document.getElementById("allowUnknown");
    var chkShowTuring = document.getElementById("showTuring");
    var chkShowMessage = document.getElementById("showMessage");
    var chkAutoShow = document.getElementById("autoShow");
    var chkShowPinpad = document.getElementById("showPinpad");
    var chkShowChangePin = document.getElementById("showChangePin");
    var turingButton = document.getElementById("TuringButton");
    var messageButton = document.getElementById("MessageButton");
    
    if (required) {
        chkSwivelOff.checked = false;
        chkAllowUnknown.checked = allowUnknown;
        chkShowTuring.checked = showTuring && !showPinpad;
        chkShowMessage.checked = showMessage;
        chkAutoShow.checked = autoShow && (showTuring || showPinpad) && !showMessage;
        chkShowPinpad.checked = showPinpad;
        chkShowChangePin.checked = showChangePin;
        if (rowTuring) {
            rowTuring.style.display = (showTuring || showMessage) ? "" : "none";
        }
        if (rowPinpad) {
            rowPinpad.style.display = showPinpad ? "" : "none";
        }
        if (turingButton) {
            turingButton.style.display = showTuring ? "" : "none";
        }
        if (messageButton) {
            messageButton.style.display = showMessage ? "" : "none";
        }
        CheckUser();
    } else {
        if (rowOtc) {
            rowOtc.style.display = "none";
        }
        if (rowTuring) {
            rowTuring.style.display = "none";
        }
        if (rowPinpad) {
            rowPinpad.style.display = "none";
        }
        if (turingButton) {
            turingButton.style.display = "none";
        }
        if (messageButton) {
            messageButton.style.display = "none";
        }
        chkSwivelOff.checked = true;
        chkAllowUnknown.checked = true;
        chkShowTuring.checked = false;
        chkShowMessage.checked = false;
        chkAutoShow.checked = false;
        chkShowPinpad.checked = false;
        chkShowChangePin.checked = false;
    }
}

function OnSwivelRequired() {
    if (xmlHttp.readyState != 4) return;
    var required = false;
    var showTuring = false;
    var showMessage = false;
    var autoShow = false;
    var allowUnknown = false;
    var showPinpad = false;
    var showChangePin = false;
    if (xmlHttp.status == 200) {
        var resultText = ExtractText(xmlHttp.responseText);
        if (resultText.length >= 7) {
            required = (resultText.charAt(0) == "1");
            allowUnknown = (resultText.charAt(1) == "1");
            showTuring = (resultText.charAt(2) == "1");
            showMessage = (resultText.charAt(3) == "1");
            autoShow = (resultText.charAt(4) == "1");
            showPinpad = (resultText.charAt(5) == "1");
            showChangePin = (resultText.charAt(6) == "1");
        }
    }
    SetSwivelSettings(required, allowUnknown, showTuring, showMessage, autoShow, showPinpad, showChangePin);
    CheckUser();
}

function CheckClient() {
    var chkSwivelOff = document.getElementById("noSwivel");
    chkSwivelOff.checked = true;
    var pinsafeUrl = GetSwivelUrl("CheckClient.aspx");
    xmlHttp = CreateXMLHttpRequest();
    xmlHttp.onreadystatechange = OnSwivelRequired;
    xmlHttp.open("GET", pinsafeUrl, true);
    xmlHttp.send(null);
}

function ShowImage() {
    if (document.getElementById("showTuring").checked) {
        ShowTuring();
    } else if (document.getElementById("showPinpad").checked) {
        ShowPinpad();
    } else if (document.getElementById("showMessage").checked) {
        ShowMessage();
    }
}

function ShowTuring() {
    var username = GetUsername();
    if (username && username != "") {
        var divTuring = document.getElementById("divTuring");
        divTuring.style.display = "";
        var turing = document.getElementById("TuringImage");
        turing.src = GetSwivelUrl("SCImage.aspx?username=") + username + "&random=" + Math.floor(Math.random() * 100000);
    }
}

function ShowMessage() {
    var username = GetUsername();
    if (username && username != "") {
        var divTuring = document.getElementById("divTuring");
        divTuring.style.display = "";
        var turing = document.getElementById("TuringImage");
        turing.src = GetSwivelUrl("SCImage.aspx?type=message&username=") + username + "&random=" + Math.floor(Math.random() * 100000);
    }
}

var pinpadRequest;

function OnPinpadShow() {
    if (pinpadRequest.readyState != 4) return;
    if (pinpadRequest.status == 200) {
        var sessionId = pinpadRequest.responseText;
        if (sessionId && sessionId != "") {
            var padno = Math.floor(Math.random() * 10000);
            for (var idx = 0; idx < 10; idx++) {
                var img = document.getElementById("imgPinpad" + idx);
                if (img) {
                    img.src = GetSwivelUrl("SCPinpad.aspx?sessionid=") + sessionId + "&padno=" + padno + ":" + idx;
                }
            }
        }
    }
}

function ShowPinpad() {
    var username = GetUsername();
    if (username && username != "") {
        var pinpad = document.getElementById("divPinpad");
        pinpad.style.display = "";
        
        pinpadRequest = CreateXMLHttpRequest();
        pinpadRequest.onreadystatechange = OnPinpadShow;
        var sessionStartUrl = GetSwivelUrl("SessionStart.aspx?username=") + username + "&random=" + Math.floor(Math.random() * 100000);
        pinpadRequest.open("GET", sessionStartUrl, true);
        pinpadRequest.send(null);
    }
}

function AddDigit(digit) {
    var textField = document.getElementById("otc");
    if (textField) {
        textField.value = textField.value + digit;
    }
    return false;
}

function ClearOtc() {
    var otcField = document.getElementById("otc");
    if (otcField) {
        otcField.value = "";
    }
}